/******************************************************************************
*search-copy-pasteプラグイン
*background.js
*記事を書いていて、引用したいとき、検索してコピーし、それを記事にペーストするプラグインです。
*使い方：
*記事と同一ページにpop画面を開き、例えばそこでyahooサーチしてコピーペーストします。
*pop画面にiframeでサーチサイト(yahooサーチ、wiki他)をリクエストします。
*
******************************************************************************/
let tabId;
let frm_arr_ = [];
//リスナーを登録すると、以後は、アクションがあるごとにこの処理を実行
//引数は、targetとfilesのオブジェクト
chrome.action.onClicked.addListener(
async (tab) => {
console.log("これは、executeScriptSampleプラグインです。");
//
chrome.scripting.executeScript({
     target: {tabId: tab.id, frameIds: [0]},

     files: ["jquery.js","jquery-ui.js"]
 }).then(() => {
     /*******************************************************************
      *executeScript()を起動します。
      *  
      *******************************************************************/
     console.log("■■■executeScript()を起動します。　" + 0);
     //ここでもexecuteScript()を出す
     try {
         chrome.scripting.executeScript({
             //ターゲットのフレームIdのDOMへアクセス  
             target: {tabId: tab.id, frameIds: [0]},
             args: [],
             //実際に実行するexcuteScriptコード
             //ここで、タイトル他をsaveTitle[]に保存するsaveTitleメッセージを
             //background.jsへ送信
             func: () => {
                    console.log("executeScript Test: "+document.title+"  ");
                    if ($("#pop").length === 0) {
                        let html = "";
                        html += "<div id='pop' style='z-index:9999;padding:13px;overflow:scroll;background-color:lightpink;position:fixed;top:0%;left:50%;width:800px;height:400px;'>\n\<span style='zoom:1.2;display:block;background-color:lightgreen;'>pop画面(search-copy-pasteプラグイン)</span>\n\
                        <button id='reset' style='position:absolute;top:15%;left:79%;zoom:1.1;float:left;'>リセット</button>\n\
                        <div id='mess' style='position:relative;top:5%;'></div>\n\
                        <button id='minus' style='zoom:1.5;position:relative;top:0%;left:50%;background-color:lightyellow'>－</button><button id='plus' style='zoom:1.5;position:relative;top:0%;left:55%;background-color:lightyellow'>＋</button>\n\
                        <iframe id='search_site' style='position:relative;top:10%;zoom:1.0;width:1450px;height:600px;' src='https://www.bing.com/search?q=%E7%81%AB%E9%87%8E%E6%AD%A3%E5%B9%B3'></frame>\n\
                        </div>";
                        $("body").append(html);
                        $("#pop").draggable();
                        $("#mess").html("executeScriptで実行<br>拡張機能ボタンがクリックされました。pop画面を追加しました。<br>ページタイトル:<br><span style='color:blue;font-weight:bold;'>"+document.title+"</span>");

                    }else{          
                        $("#mess").html("executeScriptで実行<br>拡張機能ボタンがクリックされました。pop画面がすでにあります。<br>ページタイトル:<br><span style='color:blue;font-weight:bold;'>"+document.title+"</span>");


                    }
                     $("#mess").css("display","block");
                    //
                    //ここで、登録は? セレクターが存在すること。
                    //
                    $("#reset").off('click');
                    $("#reset").on('click',()=>{
                        //alert("executeScript()で定義したリスナーを実行");
                        $("#mess").css("display","none");
                        $("#reset").off('click');
                        return false;
                        
                    });
                    /*******************************************************************
                    *これは、iframeのbingを拡大、縮小するため、
                    *background.jsへ"updown"メッセージを送信して、bingでexecuteScriptを実行  
                    *******************************************************************/
                    chrome.runtime.sendMessage({type: "updown"}, function (response) {

                    });
                    

                    
                    

}       //end func() executeScript()
});         //end executeScript()

}
catch (e) {

}
});


}        
);
/****************************************************************
*
*search_siteメッセージ受信
*  
****************************************************************/
chrome.runtime.onMessage.addListener(
        function (msg, sender, sendResponse) {
            /*************************************************
             *メッセージチェック
             *content.jsからのメッセージを待つ。
             * 
             **************************************************/
            //tabId = get_tabId();
            switch (msg.type) {
                /************************************************************
                *search_siteメッセージ受信 
                ***************************************************************/
                case "search_site":

                    chrome.tabs.query({}, tabs => {
                        for (const tab of tabs) {
                            /*********************************************************
                             *bingサイトチェック
                             *ここで、今開いているタブのみにする　アクティブのタブ  
                             *********************************************************/
                            if (tab.active === true) {
                                //タブは、すべてのhttps://サイトで
                                if (tab.url.indexOf("https://") !== -1) {
                                    tabId = tab.id;
                                    console.log("ここで、tabIdをセット　" + tabId);
                                    /*******************************************************
                                    *今のタブの中のpop画面にあるiframe(bingサイト)を探す 
                                    *********************************************************/
                                    chrome.webNavigation.getAllFrames({tabId: tabId}).then(logFrameInfo);
                                    //
                                    function logFrameInfo(framesInfo) {
                                        //
                                        const frm_arr = Object.values(framesInfo);
                                        frm_arr_ = [];
                                        for (const frm of frm_arr) {
                                            //ここで、frm.urlをチェック　必要なものだけ保存
                                            //bingサイト
                                            if (frm.frameType === "sub_frame" && (frm.url.indexOf("https://www.bing.com/search") !== -1)) {
                                                frm_arr_.push(frm.frameId);
                                            }else{
                                                continue;
                                            }
                                            /*********************************************************
                                            *ひとつ検出毎に 
                                            ***************************************************************/
                                            try {
                                                /*********************************************************
                                                 *bingサイトiframeチェック
                                                 *今開いているタブのみにする　アクティブのタブ
                                                 *frameType sub_frameのみ
                                                 *    
                                                 *********************************************************/
                                                if (frm.frameType === "sub_frame" && (frm.url.indexOf("https://www.bing.com/search") !== -1)) {
                                                        //executeScript()を実行
                                                        //filesとfuncを同時に指定できないので分けて出す。
                                                        chrome.scripting.executeScript({
                                                            target: {tabId: tabId, frameIds: [frm.frameId]},
                                                            files: ["jquery.js"]
                                                        }).then(() => {
                                                                    /*******************************************************************
                                                                     *executeScript()を起動します。
                                                                     *  
                                                                     *******************************************************************/
                                                                    console.log("■■■executeScript()を起動します。　" + frm.frameId);
                                                                    //ここでもexecuteScript()を出す
                                                                    try {
                                                                        chrome.scripting.executeScript({
                                                                            //ターゲットのフレームIdのDOMへアクセス  
                                                                            target: {tabId: tabId, frameIds: [frm.frameId]},
                                                                            args: [],
                                                                            //実際に実行するexcuteScriptコード
                                                                            func: () => {
                                                                                /***************************************************************************
                                                                                *search_site
                                                                                *この時のframeIdは、bingのブラウザーを表示しているiframe
                                                                                *リスナー登録
                                                                                *この#search_siteセレクターは、bingのブラウザーを表示しているiframeだが、
                                                                                *clickしても反応しない?? bodyならばOK bodyは、bingのbody
                                                                                ****************************************************************/
//                                                                                $("body").on('click',()=>{
//                                                                                    alert("body");
//                                                                                });
                                                                                $(document).on('click',()=>{
                                                                                    alert("iframe");
                                                                                    return false;
                                                                                });
                                                                              
                                                                                
                                                                                   console.log("セレクターチェック"); 
                                                                                   alert("セレクターチェック"); 
                                                                            }       //end func() executeScript()
                                                                        });         //end executeScript()

                                                                    }
                                                                    catch (e) {

                                                                    }
                                                            });
                                                    }

                                                }
                                                catch (e) {

                                                }

                                            }       // end for()
                                        }
                                    //break;
                                }
                                //sleep(0.5);
                            }
                        }

                    });
                    return true;
                    break;
               /*
               * 
               */     
               case "updown": 
                   chrome.tabs.query({}, tabs => {
                        for (const tab of tabs) {
                            /*********************************************************
                             *bingサイトチェック
                             *ここで、今開いているタブのみにする　アクティブのタブ  
                             *********************************************************/
                            if (tab.active === true) {
                                //タブは、すべてのhttps://サイトで
                                if (tab.url.indexOf("https://") !== -1) {
                                    tabId = tab.id;
                                    console.log("ここで、tabIdをセット　" + tabId);
                                    /*******************************************************
                                    *今のタブの中のpop画面にあるiframe(bingサイト)を探す 
                                    *********************************************************/
                                    chrome.webNavigation.getAllFrames({tabId: tabId}).then(logFrameInfo);
                                    //
                                    function logFrameInfo(framesInfo) {
                                        //
                                        const frm_arr = Object.values(framesInfo);
                                        frm_arr_ = [];
                                        for (const frm of frm_arr) {
                                            //ここで、frm.urlをチェック　必要なものだけ保存
                                            //bingサイト
                                            if (frm.frameType === "sub_frame" && (frm.url.indexOf("https://www.bing.com/search") !== -1)) {
                                                frm_arr_.push(frm.frameId);
                                            }else{
                                                continue;
                                            }
                                            /*********************************************************
                                            *ひとつ検出毎に 
                                            ***************************************************************/
                                            try {
                                                /*********************************************************
                                                 *bingサイトiframeチェック
                                                 *今開いているタブのみにする　アクティブのタブ
                                                 *frameType sub_frameのみ
                                                 *    
                                                 *********************************************************/
                                                if (frm.frameType === "sub_frame" && (frm.url.indexOf("https://www.bing.com/search") !== -1)) {
                                                        //executeScript()を実行
                                                        //filesとfuncを同時に指定できないので分けて出す。
                                                        chrome.scripting.executeScript({
                                                            target: {tabId: tabId, frameIds: [0]},
                                                            files: ["jquery.js"]
                                                        }).then(() => {
                                                                    /*******************************************************************
                                                                     *executeScript()を起動します。
                                                                     *  
                                                                     *******************************************************************/
                                                                    console.log("■■■executeScript()を起動します。　" + frm.frameId);
                                                                    //ここでもexecuteScript()を出す
                                                                    try {
                                                                        chrome.scripting.executeScript({
                                                                            //ターゲットのフレームIdのDOMへアクセス  
                                                                            target: {tabId: tabId, frameIds: [0]},
                                                                            args: [],
                                                                            //実際に実行するexcuteScriptコード
                                                                            func: () => {
                                                                                
                                                                                //10%ずつ縮小　zoom:10%
                                                                                $("#minus").on('click',()=>{
                                                                                    let vv = Number($("body")[0].attributes.style.nodeValue.split(";")[0].split(":")[1]);
                                                                                    vv -= 0.1;
                                                                                    $("body").css("zoom",vv.toString());
                                                                                    alert(vv);

                                                                                });
                                                                                //10%ずつ拡大 zoom:10%
                                                                                $("#plus").on('click',()=>{
                                                                                    let vv = Number($("body")[0].attributes.style.nodeValue.split(";")[0].split(":")[1]);

                                                                                    vv += 0.1;
                                                                                    $("body").css("zoom",vv.toString());
                                                                                    alert(vv);

                                                                                });

                                                                            }       //end func() executeScript()
                                                                        });         //end executeScript()

                                                                    }
                                                                    catch (e) {

                                                                    }
                                                            });
                                                    }

                                                }
                                                catch (e) {

                                                }

                                            }       // end for()
                                        }
                                    //break;
                                }
                                //sleep(0.5);
                            }
                        }

                    });
                    
                   return true;
                   break;
            }
        }
);        
/**************************************************************
*tabId = get_tabId();
*返却値　アクティブタブのtabId
* 
**************************************************************/
//async function get_tabId(){
//        tabId =await chrome.tabs.query({}, tabs => {
//            
//            for (const tab of tabs) {
//                /*********************************************************
//                 *iframeプレーヤーチェック
//                 *ここで、今開いているタブのみにする　アクティブのタブ  
//                 *********************************************************/
//                if (tab.active === true) {
//                    if (tab.url.indexOf("https://") !== -1) {
//                        return tab.id;
//                        //console.log("ここで、tabIdをセット　" + tabId);
//                        break;
//                    }
//                }
//            }
//        });
//        return tabId;
//}
